//---------------------------------------------------------------------------
#ifndef App_CommandsH
#define App_CommandsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "App_DiskImages.h"
#include "Moa_CommandPattern.h"
#include "Moa_ListViews.h"
//---------------------------------------------------------------------------
namespace App_commands {
//---------------------------------------------------------------------------
class TEditCommand : public TCommand
{
private:
	AnsiString FDescription;
protected:
public:
	__fastcall TEditCommand();
	virtual __fastcall ~TEditCommand();
	__property AnsiString Description = {read=FDescription, write=FDescription};
};
//---------------------------------------------------------------------------
class TMultiEditCommand : public TEditCommand
{
private:
	TInvoker* FInvoker;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
protected:
public:
	__fastcall TMultiEditCommand();
	virtual __fastcall ~TMultiEditCommand();
	__property TInvoker* Invoker = {read=FInvoker};
};
//---------------------------------------------------------------------------
class TGrowSubCommand : public TEditCommand
{
private:
	int FIndex;
	TDiskImage* FItem;
	bool FOwnItem;
protected:
public:
	__fastcall TGrowSubCommand();
	virtual __fastcall ~TGrowSubCommand();
	__property int Index = {read=FIndex, write=FIndex};
	__property TDiskImage* Item = {read=FItem, write=FItem};
	__property bool OwnItem = {read=FOwnItem, write=FOwnItem};
};
//---------------------------------------------------------------------------
class TReorderSubCommand : public TEditCommand
{
private:
	int FIndex1;
	int FIndex2;
protected:
public:
	__fastcall TReorderSubCommand();
	virtual __fastcall ~TReorderSubCommand();
	__property int Index1 = {read=FIndex1, write=FIndex1};
	__property int Index2 = {read=FIndex2, write=FIndex2};
};
//---------------------------------------------------------------------------
class TSetNamePropertySubCommand : public TEditCommand
{
private:
	TDiskImage* FItem;
	AnsiString FValue;
protected:
public:
	__fastcall TSetNamePropertySubCommand();
	virtual __fastcall ~TSetNamePropertySubCommand();
	__property TDiskImage* Item = {read=FItem, write=FItem};
	__property AnsiString Value = {read=FValue, write=FValue};
};
//---------------------------------------------------------------------------
class TSetWriteProtectedPropertySubCommand : public TEditCommand
{
private:
	TDiskImage* FItem;
	int FValue;
protected:
public:
	__fastcall TSetWriteProtectedPropertySubCommand();
	virtual __fastcall ~TSetWriteProtectedPropertySubCommand();
	__property TDiskImage* Item = {read=FItem, write=FItem};
	__property int Value = {read=FValue, write=FValue};
};
//---------------------------------------------------------------------------
} // End namespace App_commands
using namespace App_commands;
//---------------------------------------------------------------------------
#endif

