//---------------------------------------------------------------------------
#ifndef App_ViewHandlerH
#define App_ViewHandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include "App_Handler.h"
//---------------------------------------------------------------------------
namespace App_viewhandler {
//---------------------------------------------------------------------------
class TViewHandler : public THandler
{
private:
	static const AnsiString SettingsSection;
	TToolBar* FToolbar;
	TStatusBar* FStatusBar;
	TListView* FListView;
	void __fastcall Initialize(TToolBar* AToolbar, TStatusBar* AStatusBar, TListView* AListView);
	void __fastcall Uninitialize();
	bool __fastcall GetShowToolbar();
	void __fastcall SetShowToolbar(bool AShowToolbar);
	bool __fastcall GetShowStatusBar();
	void __fastcall SetShowStatusBar(bool AShowStatusBar);
	bool __fastcall GetRowSelect();
	void __fastcall SetRowSelect(bool ARowSelect);
protected:
public:
	__fastcall TViewHandler(TToolBar* AToolbar, TStatusBar* AStatusBar, TListView* AListView);
	virtual __fastcall ~TViewHandler();
	virtual void __fastcall ToggleShowToolbar();
	virtual bool __fastcall CanToggleShowToolbar();
	virtual void __fastcall ToggleShowStatusBar();
	virtual bool __fastcall CanToggleShowStatusBar();
	virtual void __fastcall ToggleRowSelect();
	virtual bool __fastcall CanToggleRowSelect();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile);
	__property TToolBar* Toolbar = {read=FToolbar};
	__property TStatusBar* StatusBar = {read=FStatusBar};
	__property TListView* ListView = {read=FListView};
	__property bool ShowToolbar = {read=GetShowToolbar};
	__property bool ShowStatusBar = {read=GetShowStatusBar};
	__property bool RowSelect = {read=GetRowSelect};
};
//---------------------------------------------------------------------------
} // End namespace App_viewhandler
using namespace App_viewhandler;
//---------------------------------------------------------------------------
#endif

