//---------------------------------------------------------------------------
// Version: 1.1.0
// Date: 2012-03-15 UTC+09:00
// Version: 1.0.0
// Date: 2011-08-08 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointers.h"
#include "Moa_DynamicArrays.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TStringDynArray __fastcall TStringArrayUtilities::FromList(TStrings* AList)
{
	TStringDynArray LArray;
	LArray.Length = AList->Count;
	for(int LI = 0; LI < LArray.Length; ++LI) {
		LArray[LI] = AList->Strings[LI];
	}
	return LArray;
}
//---------------------------------------------------------------------------
void __fastcall TStringArrayUtilities::ToList(const TStringDynArray& AArray, TStrings* AList)
{
	TAutoPointer<TStrings> LList = new TStringList();
	LList->Capacity = AArray.Length;
	for(int LI = 0; LI < AArray.Length; ++LI) {
		LList->Add(AArray[LI]);
	}
	AList->Assign(LList);
}
//---------------------------------------------------------------------------
TStringDynArray __fastcall TStringArrayUtilities::FromText(const AnsiString& AText)
{
	TAutoPointer<TStrings> LList = new TStringList();
	LList->Text = AText;
	return FromList(LList);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringArrayUtilities::ToText(const TStringDynArray& AArray)
{
	TAutoPointer<TStrings> LList = new TStringList();
	ToList(AArray, LList);
	return LList->Text;
}
//---------------------------------------------------------------------------
TStringDynArray __fastcall TStringArrayUtilities::FromCommaText(const AnsiString& ACommaText)
{
	TAutoPointer<TStrings> LList = new TStringList();
	LList->CommaText = ACommaText;
	return FromList(LList);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringArrayUtilities::ToCommaText(const TStringDynArray& AArray)
{
	TAutoPointer<TStrings> LList = new TStringList();
	ToList(AArray, LList);
	return LList->CommaText;
}
//---------------------------------------------------------------------------
TStringDynArray __fastcall TStringArrayUtilities::RemoveBlankLines(const TStringDynArray& AArray)
{
	TAutoPointer<TStrings> LLines = new TStringList();
	ToList(AArray, LLines);
	for(int LI = 0; LI < LLines->Count; ++LI) {
		if(LLines->Strings[LLines->Count - 1 - LI].Length() == 0) {
			LLines->Delete(LLines->Count - 1 - LI);
		}
	}
	return FromList(LLines);
}
//---------------------------------------------------------------------------

