//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_AutoPointers.h"
#include "Moa_Files.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-08-27 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
namespace Moa_files {
//---------------------------------------------------------------------------
const char* TPathUtilities::DeviceNames[] = {
	"CON", "PRN", "AUX", "NUL",
	"COM1", "COM2", "COM3", "COM4", "COM5", "COM6", "COM7", "COM8", "COM9",
	"LPT1", "LPT2", "LPT3", "LPT4", "LPT5", "LPT6", "LPT7", "LPT8", "LPT9",
};
const int TPathUtilities::DeviceNameCount = sizeof(DeviceNames) / sizeof(char*);
const char* TPathUtilities::DotName = ".";
const char* TPathUtilities::DotDotName = "..";
const char* TPathUtilities::Separators = ":\\.";
const char* TPathUtilities::WildcardCharacters = "*?";
const char TPathUtilities::DriveSeparator = ':';
const char TPathUtilities::DirectorySeparator = '\\';
const char TPathUtilities::ExtensionSeparator = '.';
const char TPathUtilities::AnyWildcardCharacter = '*';
const char TPathUtilities::OneWildcardCharacter = '?';
const bool TPathUtilities::PathCharacterTable[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
}; // 0: {0 - 31} [<] [>] ["] [/] [|] [?] [*]
const int TPathUtilities::PathCharacterTableSize = sizeof(PathCharacterTable) / sizeof(bool);
const bool TPathUtilities::NameCharacterTable[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
}; // 0: {0 - 31} [<] [>] [:] ["] [/] [\] [|] [?] [*]
const int TPathUtilities::NameCharacterTableSize = sizeof(NameCharacterTable) / sizeof(bool);
const bool TPathUtilities::SeparatorTable[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
}; // 1: [:] [\] [.]
const int TPathUtilities::SeparatorTableSize = sizeof(SeparatorTable) / sizeof(bool);
const bool TPathUtilities::WildcardCharacterTable[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
}; // 1: [?] [*]
const int TPathUtilities::WildcardCharacterTableSize = sizeof(WildcardCharacterTable) / sizeof(bool);
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::BeginWithSeparator(const AnsiString& APath, char ASeparator)
{
	if(BeginsWithSeparator(APath, ASeparator)) {
		return APath;
	}
	return AnsiString(ASeparator) + APath;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::BeginsWithSeparator(const AnsiString& APath, char ASeparator)
{
	return APath.Length() > 0 && APath[1] == ASeparator;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::EndWithSeparator(const AnsiString& APath, char ASeparator)
{
	if(EndsWithSeparator(APath, ASeparator)) {
		return APath;
	}
	return APath + AnsiString(ASeparator);
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::EndsWithSeparator(const AnsiString& APath, char ASeparator)
{
	return APath.Length() > 0 && *APath.AnsiLastChar() == ASeparator;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::ReplaceInvalidPathCharacters(const AnsiString& APath, char ANewCharacter)
{
	AnsiString LPath = APath;
	int LIndex;
	while((LIndex = FindInvalidPathCharacter(LPath)) >= 1) {
		LPath[LIndex] = ANewCharacter;
	}
	return LPath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::ReplaceInvalidNameCharacters(const AnsiString& AName, char ANewCharacter)
{
	AnsiString LName = AName;
	int LIndex;
	while((LIndex = FindInvalidNameCharacter(LName)) >= 1) {
		LName[LIndex] = ANewCharacter;
	}
	return LName;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::RemoveInvalidPathCharacters(const AnsiString& APath)
{
	AnsiString LPath = APath;
	int LIndex;
	while((LIndex = FindInvalidPathCharacter(LPath)) >= 1) {
		LPath.Delete(LIndex, 1);
	}
	return LPath;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPathUtilities::RemoveInvalidNameCharacters(const AnsiString& AName)
{
	AnsiString LName = AName;
	int LIndex;
	while((LIndex = FindInvalidNameCharacter(LName)) >= 1) {
		LName.Delete(LIndex, 1);
	}
	return LName;
}
//---------------------------------------------------------------------------
int __fastcall TPathUtilities::FindSeparator(const AnsiString& APath)
{
	for(int LI = 0; LI < APath.Length(); ++LI) {
		if(IsSeparator(APath[LI + 1])) {
			return LI + 1;
		}
		if(::IsDBCSLeadByte(APath[LI + 1])) {
			++LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------
int __fastcall TPathUtilities::FindInvalidPathCharacter(const AnsiString& APath)
{
	for(int LI = 0; LI < APath.Length(); ++LI) {
		if(!IsPathCharacter(APath[LI + 1])) {
			return LI + 1;
		}
		if(::IsDBCSLeadByte(APath[LI + 1])) {
			++LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------
int __fastcall TPathUtilities::FindInvalidNameCharacter(const AnsiString& AName)
{
	for(int LI = 0; LI < AName.Length(); ++LI) {
		if(!IsNameCharacter(AName[LI + 1])) {
			return LI + 1;
		}
		if(::IsDBCSLeadByte(AName[LI + 1])) {
			++LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------
int __fastcall TPathUtilities::FindWildcardCharacter(const AnsiString& APath)
{
	for(int LI = 0; LI < APath.Length(); ++LI) {
		if(IsWildcardCharacter(APath[LI + 1])) {
			return LI + 1;
		}
		if(::IsDBCSLeadByte(APath[LI + 1])) {
			++LI;
		}
	}
	return -1;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsAbsolutePath(const AnsiString& APath)
{
	return ExtractFileDrive(APath).Length() > 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsRelativePath(const AnsiString& APath)
{
	return !IsAbsolutePath(APath);
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsDeviceName(const AnsiString& AName)
{
	for(int LI = 0; LI < DeviceNameCount; ++LI) {
		if(AnsiCompareFileName(DeviceNames[LI], AName) == 0) {
			return true;
		}
	}
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsDotName(const AnsiString& AName)
{
	return AnsiCompareFileName(DotName, AName) == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsDotDotName(const AnsiString& AName)
{
	return AnsiCompareFileName(DotDotName, AName) == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsPathCharacter(char ACharacter)
{
	int LIndex = static_cast<unsigned char>(ACharacter);
	if(LIndex >= PathCharacterTableSize) {
		throw EFileError("The program cannot determine whether the character can be used for a path.");
	}
	return PathCharacterTable[LIndex];
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsNameCharacter(char ACharacter)
{
	int LIndex = static_cast<unsigned char>(ACharacter);
	if(LIndex >= NameCharacterTableSize) {
		throw EFileError("The program cannot determine whether the character can be used for a file name.");
	}
	return NameCharacterTable[LIndex];
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsSeparator(char ACharacter)
{
	int LIndex = static_cast<unsigned char>(ACharacter);
	if(LIndex >= SeparatorTableSize) {
		throw EFileError("The program cannot determine whether the character is a separator.");
	}
	return SeparatorTable[LIndex];
}
//---------------------------------------------------------------------------
bool __fastcall TPathUtilities::IsWildcardCharacter(char ACharacter)
{
	int LIndex = static_cast<unsigned char>(ACharacter);
	if(LIndex >= WildcardCharacterTableSize) {
		throw EFileError("The program cannot determine whether the character is a wildcard character.");
	}
	return WildcardCharacterTable[LIndex];
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
AnsiString __fastcall TFileUtilities::GetLongPath(const AnsiString& APath) 
{
	AnsiString LLongPath;
	if(!TryGetLongPath(APath, LLongPath)) {
		throw EFileError("The program could not get the long form of the path.");
	}
	return LLongPath;
}
//---------------------------------------------------------------------------
bool __fastcall TFileUtilities::TryGetLongPath(const AnsiString& APath, AnsiString& ALongPath) 
{
	if(ALongPath.Length() >= MAX_PATH || TPathUtilities::FindWildcardCharacter(ALongPath) >= 1) {
		return false;
	}
	DWORD LBufferSize = ::GetLongPathName(APath.c_str(), NULL, 0);
	if(LBufferSize == 0) {
		return false;
	}
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	DWORD LPathLength = ::GetLongPathName(APath.c_str(), LBuffer, LBufferSize);
	if(LPathLength == 0) {
		return false;
	}
	ALongPath = AnsiString(LBuffer, LPathLength);
	return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileUtilities::GetShortPath(const AnsiString& APath) 
{
	AnsiString LShortPath;
	if(!TryGetShortPath(APath, LShortPath)) {
		throw EFileError("The program could not get the short form of the path.");
	}
	return LShortPath;
}
//---------------------------------------------------------------------------
bool __fastcall TFileUtilities::TryGetShortPath(const AnsiString& APath, AnsiString& AShortPath) 
{
	if(AShortPath.Length() >= MAX_PATH || TPathUtilities::FindWildcardCharacter(AShortPath) >= 1) {
		return false;
	}
	DWORD LBufferSize = ::GetShortPathName(APath.c_str(), NULL, 0);
	if(LBufferSize == 0) {
		return false;
	}
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	DWORD LPathLength = ::GetShortPathName(APath.c_str(), LBuffer, LBufferSize);
	if(LPathLength == 0) {
		return false;
	}
	AShortPath = AnsiString(LBuffer, LPathLength);
	return true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TDirectoryEntryEnumerator::FindFirst()
{
	::ZeroMemory(&FCurrent, sizeof(WIN32_FIND_DATA));
	FHandle = ::FindFirstFile(Mask.c_str(), &FCurrent);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryEntryEnumerator::FindNext()
{
	::ZeroMemory(&FCurrent, sizeof(WIN32_FIND_DATA));
	if(!::FindNextFile(Handle, &FCurrent)) {
		Finish();
	}
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryEntryEnumerator::Finish()
{
	if(!IsStarted() || IsFinished()) {
		return;
	}
	::FindClose(Handle);
	FHandle = INVALID_HANDLE_VALUE;
}
//---------------------------------------------------------------------------
bool __fastcall TDirectoryEntryEnumerator::IsStarted()
{
	return Handle != NULL;
}
//---------------------------------------------------------------------------
bool __fastcall TDirectoryEntryEnumerator::IsFinished()
{
	return Handle == INVALID_HANDLE_VALUE;
}
//---------------------------------------------------------------------------
__fastcall TDirectoryEntryEnumerator::TDirectoryEntryEnumerator(const AnsiString& AMask) :
	TObject(),
	FHandle(NULL),
	FMask(AMask),
	FCurrent()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TDirectoryEntryEnumerator::~TDirectoryEntryEnumerator()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TDirectoryEntryEnumerator::MoveNext()
{
	if(IsFinished()) {
		throw EFileError("The program cannot get any more directory entries.");
	}
	if(IsStarted()) {
		FindNext();
	}
	else {
		FindFirst();
	}
	return IsStarted() && !IsFinished();
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryEntryEnumerator::Reset()
{
	Finish();
	FHandle = NULL;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int __fastcall TPathList::CompareStrings(const AnsiString AString1, const AnsiString AString2)
{
	return Sysutils::AnsiCompareFileName(AString1, AString2);
}
//---------------------------------------------------------------------------
__fastcall TPathList::TPathList() :
	TStringList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TPathList::~TPathList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace Moa_files
//---------------------------------------------------------------------------

