//---------------------------------------------------------------------------
#ifndef Moa_ListViewsH
#define Moa_ListViewsH
//---------------------------------------------------------------------------
// Version: 1.0.1
// Date: 2011-04-18 UTC+09:00
// Version: 1.0.0
// Date: 2011-08-30 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
namespace Moa_listviews {
//---------------------------------------------------------------------------
class TListViewShell : public TObject
{
private:
	TListView* FListView;
	UINT __fastcall GetState(int AIndex);
	void __fastcall SetState(int AIndex, UINT AState);
	int __fastcall GetCount();
	void __fastcall SetCount(int ACount);
	int __fastcall GetFocusedIndex();
	void __fastcall SetFocusedIndex(int AFocusedIndex);
	int __fastcall GetFocusedCount();
	int __fastcall GetSelectedIndex();
	void __fastcall SetSelectedIndex(int ASelectedIndex);
	TIntegerDynArray __fastcall GetSelectedIndexes();
	void __fastcall SetSelectedIndexes(const TIntegerDynArray& ASelectedIndexes);
	int __fastcall GetSelectedCount();
protected:
public:
	__fastcall TListViewShell(TListView* AListView);
	virtual __fastcall ~TListViewShell();
	virtual int __fastcall Add();
	virtual void __fastcall Insert(int AIndex);
	virtual void __fastcall Delete(int AIndex);
	virtual void __fastcall Clear();
	virtual void __fastcall Exchange(int AIndex1, int AIndex2);
	virtual void __fastcall Move(int AOldIndex, int ANewIndex);
	virtual void __fastcall SelectAll();
	virtual void __fastcall ReverseSelection();
	virtual void __fastcall ClearSelection();
	virtual void __fastcall EnsureVisible(int AIndex, bool AAllowPartial);
	virtual bool __fastcall IsCut(int AIndex);
	virtual void __fastcall SetCut(int AIndex, bool ACut);
	virtual bool __fastcall IsDropTarget(int AIndex);
	virtual void __fastcall SetDropTarget(int AIndex, bool ADropTarget);
	virtual bool __fastcall IsFocused(int AIndex);
	virtual void __fastcall SetFocused(int AIndex, bool AFocused);
	virtual bool __fastcall IsSelected(int AIndex);
	virtual void __fastcall SetSelected(int AIndex, bool ASelected);
	virtual void __fastcall Invalidate();
	virtual void __fastcall Update();
	virtual void __fastcall Repaint();
	virtual void __fastcall Refresh();
	virtual void __fastcall BeginUpdate();
	virtual void __fastcall EndUpdate();
	__property UINT States[int AIndex] = {read=GetState, write=SetState};
	__property int Count = {read=GetCount, write=SetCount};
	__property int FocusedIndex = {read=GetFocusedIndex, write=SetFocusedIndex};
	__property int FocusedCount = {read=GetFocusedCount};
	__property int SelectedIndex = {read=GetSelectedIndex, write=SetSelectedIndex};
	__property TIntegerDynArray SelectedIndexes = {read=GetSelectedIndexes, write=SetSelectedIndexes};
	__property int SelectedCount = {read=GetSelectedCount};
	__property TListView* ListView = {read=FListView};
};
//---------------------------------------------------------------------------
} // End namespace Moa_listviews
using namespace Moa_listviews;
//---------------------------------------------------------------------------
#endif

