//---------------------------------------------------------------------------
#ifndef Moa_ListsH
#define Moa_ListsH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-08-26 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_lists {
//---------------------------------------------------------------------------
struct TListOperatorReorderRecord
{
	int Index1;
	int Index2;
};
typedef DynamicArray<TListOperatorReorderRecord> TListOperatorReorderRecords;
typedef int __fastcall (* TListOperatorSortCompare)(TList* AList, int AIndex1, int AIndex2, void* AData);
//---------------------------------------------------------------------------
class TListOperator : public TObject
{
private:
	struct TSortRecord
	{
		TList* List;
		int OldIndex;
		int NewIndex;
		TListOperatorSortCompare Compare;
		void* Data;
	};
	struct TSlideRecord
	{
		int OldIndex;
		int NewIndex;
		bool Target;
	};
	static int __fastcall CompareSortRecord(void* AItem1, void* AItem2);
protected:
public:
	static void __fastcall Sort(TList* AList, TListOperatorSortCompare ACompare, void* AData);
	static TListOperatorReorderRecords __fastcall SimulateSort(TList* AList, TListOperatorSortCompare ACompare, void* AData);
	static void __fastcall Reverse(TList* AList);
	static TListOperatorReorderRecords __fastcall SimulateReverse(TList* AList);
	static TListOperatorReorderRecords __fastcall AbstractReverse(int ACount);
	static void __fastcall Slide(TList* AList, const TIntegerDynArray& AIndexes, int ADistance);
	static TListOperatorReorderRecords __fastcall SimulateSlide(TList* AList, const TIntegerDynArray& AIndexes, int ADistance);
	static TListOperatorReorderRecords __fastcall AbstractSlide(int ACount, const TIntegerDynArray& AIndexes, int ADistance);
	static void __fastcall Reorder(TList* AList, const TListOperatorReorderRecords& ARecords);
};
//---------------------------------------------------------------------------
} // End namespace Moa_lists
using namespace Moa_lists;
//---------------------------------------------------------------------------
#endif

