//---------------------------------------------------------------------------
#ifndef Moa_ShellLinksH
#define Moa_ShellLinksH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-09-06 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <objidl.h>
#include <shlobj.h>
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_shelllinks {
//---------------------------------------------------------------------------
class EShellLinkError : public Exception
{
public:
	__fastcall EShellLinkError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TShellLink : public TObject
{
private:
	static const int MaxCharacterLength;
	IShellLink* FShellLink;
	IPersistFile* FPersistFile;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandlePropertyGetError();
	void __fastcall HandlePropertySetError();
	AnsiString __fastcall GetTargetPath();
	void __fastcall SetTargetPath(const AnsiString& ATargetPath);
	AnsiString __fastcall GetWorkingDirectory();
	void __fastcall SetWorkingDirectory(const AnsiString& AWorkingDirectory);
	AnsiString __fastcall GetArguments();
	void __fastcall SetArguments(const AnsiString& AArguments);
	AnsiString __fastcall GetDescription();
	void __fastcall SetDescription(const AnsiString& ADescription);
	AnsiString __fastcall GetIconPath();
	void __fastcall SetIconPath(const AnsiString& AIconPath);
	int __fastcall GetIconIndex();
	void __fastcall SetIconIndex(int AIconIndex);
	int __fastcall GetShowCommand();
	void __fastcall SetShowCommand(int AShowCommand);
	WORD __fastcall GetHotKey();
	void __fastcall SetHotKey(WORD AHotKey);
protected:
public:
	__fastcall TShellLink();
	virtual __fastcall ~TShellLink();
	virtual void __fastcall Resolve(HWND ADialogParent, DWORD AFlags);
	virtual void __fastcall LoadFromFile(const AnsiString& APath);
	virtual void __fastcall SaveToFile(const AnsiString& APath);
	virtual void __fastcall GetIconLocation(AnsiString& APath, int& AIndex);
	virtual void __fastcall SetIconLocation(const AnsiString& APath, int AIndex);
	__property IShellLink* ShellLink = {read=FShellLink};
	__property IPersistFile* PersistFile = {read=FPersistFile};
	__property AnsiString TargetPath = {read=GetTargetPath, write=SetTargetPath};
	__property AnsiString WorkingDirectory = {read=GetWorkingDirectory, write=SetWorkingDirectory};
	__property AnsiString Arguments = {read=GetArguments, write=SetArguments};
	__property AnsiString Description = {read=GetDescription, write=SetDescription};
	__property AnsiString IconPath = {read=GetIconPath, write=SetIconPath};
	__property int IconIndex = {read=GetIconIndex, write=SetIconIndex};
	__property int ShowCommand = {read=GetShowCommand, write=SetShowCommand};
	__property WORD HotKey = {read=GetHotKey, write=SetHotKey};
};
//---------------------------------------------------------------------------
} // End namespace Moa_shelllinks
using namespace Moa_shelllinks;
//---------------------------------------------------------------------------
#endif

