//---------------------------------------------------------------------------
#ifndef Moa_WindowsH
#define Moa_WindowsH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-08-28 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_windows {
//---------------------------------------------------------------------------
class EWindowError : public Exception
{
public:
	__fastcall EWindowError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class EWindowMessageNotFound : public EWindowError
{
public:
	__fastcall EWindowMessageNotFound(const AnsiString& AMessage) : EWindowError(AMessage) {}
};
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TMessageEvent)(TObject* ASender, TMessage& AMessage, bool& AHandled);
//---------------------------------------------------------------------------
class TMessageWindow : public TObject
{
private:
	HWND FHandle;
	TMessageEvent FOnMessage;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleMessage(TMessage& AMessage);
protected:
	virtual bool __fastcall DoMessage(TMessage& AMessage);
public:
	__fastcall TMessageWindow();
	virtual __fastcall ~TMessageWindow();
	virtual void __fastcall Send(UINT AId, WPARAM AWParam, LPARAM ALParam);
	virtual void __fastcall Post(UINT AId, WPARAM AWParam, LPARAM ALParam);
	virtual MSG __fastcall Peek(UINT AMinId, UINT AMaxId);
	virtual bool __fastcall TryPeek(UINT AMinId, UINT AMaxId, MSG& AMessage);
	virtual MSG __fastcall Extract(UINT AMinId, UINT AMaxId);
	virtual bool __fastcall TryExtract(UINT AMinId, UINT AMaxId, MSG& AMessage);
	virtual void __fastcall Remove(UINT AMinId, UINT AMaxId);
	virtual bool __fastcall TryRemove(UINT AMinId, UINT AMaxId);
	virtual bool __fastcall Find(UINT AMinId, UINT AMaxId);
	__property HWND Handle = {read=FHandle};
	__property TMessageEvent OnMessage = {read=FOnMessage, write=FOnMessage};
};
//---------------------------------------------------------------------------
class TUpdateNotifier : public TObject
{
private:
	static const UINT WM_APP_UPDATE = WM_APP + 0;
	TMessageWindow* FMessageWindow;
	bool FInvalidated;
	TNotifyEvent FOnUpdate;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall MessageWindowMessage(TObject* ASender, TMessage& AMessage, bool& AHandled);
	__property TMessageWindow* MessageWindow = {read=FMessageWindow};
	__property bool Invalidated = {read=FInvalidated};
protected:
	virtual void __fastcall DoUpdate();
public:
	__fastcall TUpdateNotifier();
	virtual __fastcall ~TUpdateNotifier();
	virtual void __fastcall Invalidate();
	virtual void __fastcall Update();
	virtual void __fastcall Refresh();
	__property TNotifyEvent OnUpdate = {read=FOnUpdate, write=FOnUpdate};
};
//---------------------------------------------------------------------------
} // End namespace Moa_windows
using namespace Moa_windows;
//---------------------------------------------------------------------------
#endif

